/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.buff.BuffPetImpl
 *  fire.pb.course.CourseManager
 *  fire.pb.effect.PetImpl
 *  fire.pb.skill.Result
 *  fire.pb.skill.SkillPet
 *  fire.pb.talk.MessageMgr
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.PetInfo
 *  xbean.PetSkill
 *  xtable.Properties
 */
package fire.pb.pet;

import fire.pb.buff.BuffPetImpl;
import fire.pb.course.CourseManager;
import fire.pb.effect.PetImpl;
import fire.pb.pet.CalcPetAttr;
import fire.pb.pet.Helper;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.pet.SRefreshPetExp;
import fire.pb.skill.Result;
import fire.pb.skill.SkillPet;
import fire.pb.talk.MessageMgr;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.PetInfo;
import xbean.PetSkill;
import xtable.Properties;

public class PAddPetExpProc
extends Procedure {
    public static final int ADD_REASON_DEFAULT = 0;
    public static final int ADD_REASON_EXPCULTIVATE = 1;
    private final long roleId;
    private final int petKey;
    private final long addExp;
    private boolean showMsg = true;
    private int reason = 0;

    public PAddPetExpProc(long roleId, int petKey, long addExp) {
        this.roleId = roleId;
        this.petKey = petKey;
        this.addExp = addExp;
    }

    public PAddPetExpProc(long roleId, int petKey, long addExp, boolean show) {
        this.roleId = roleId;
        this.petKey = petKey;
        this.addExp = addExp;
        this.showMsg = show;
    }

    public PAddPetExpProc(long roleId, int petKey, long addExp, boolean show, int reason) {
        this(roleId, petKey, addExp, show);
        this.reason = reason;
    }

    public boolean process() {
        int newLevel;
        if (this.addExp == 0L) {
            return false;
        }
        if (Helper.isPetInBattle(this.roleId, this.petKey)) {
            return false;
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(this.petKey);
        if (pet == null) {
            return false;
        }
        PetInfo petInfo = pet.getPetInfo();
        int oldLevel = petInfo.getLevel();
        int levelSpace = 6;
        if (this.reason == 1) {
            levelSpace = 10;
        }
        int roleLevel = Properties.selectLevel((Long)this.roleId);
        if (petInfo.getLevel() >= roleLevel + levelSpace && this.addExp > 0L) {
            if (this.reason == 0) {
                MessageMgr.psendMsgNotify((long)this.roleId, (int)141794, null);
            }
            return false;
        }
        long curExp = petInfo.getExp();
        PetImpl epet = new PetImpl(this.roleId, this.petKey);
        long nextExp = epet.getNextExp();
        if (curExp + this.addExp <= 0L) {
            petInfo.setExp(0L);
        } else if (curExp + this.addExp >= nextExp) {
            Map res;
            petInfo.setExp(curExp + this.addExp);
            HashMap changeAttrs = new HashMap();
            int i = 1;
            while (petInfo.getExp() >= epet.getNextExp() && (res = epet.levelUp()) != null) {
                changeAttrs.putAll(res);
                CalcPetAttr.graspPekSkillWhileUplevel(this.roleId, this.petKey);
                if (++i <= 155) continue;
                Module.logger.error((Object)("宠物一次升级次数过多 PetExp = " + petInfo.getExp() + "NextExp = " + epet.getNextExp()));
                break;
            }
            if (!changeAttrs.isEmpty()) {
                SkillPet skillPet = new SkillPet(petInfo, this.roleId);
                Result result = skillPet.addSkillBuffWhileOnline(null);
                for (Map.Entry entry : changeAttrs.entrySet()) {
                    if (result.getChangedAttrs().containsKey(entry.getKey())) continue;
                    result.getChangedAttrs().put(entry.getKey(), entry.getValue());
                }
                BuffPetImpl buffAgent = new BuffPetImpl(this.roleId, this.petKey);
                buffAgent.psendSBuffChangeResult(result);
            }
        } else {
            petInfo.setExp(curExp + this.addExp);
        }
        if (this.addExp > 0L && this.showMsg) {
            ArrayList<String> params = new ArrayList<String>();
            params.add(petInfo.getName());
            PetAttr petAttr = Module.getInstance().getPetManager().getAttr(petInfo.getId());
            if (petAttr != null) {
                params.add(petAttr.getColour());
            } else {
                params.add("ffff0000");
            }
            params.add(Long.toString(this.addExp));
            MessageMgr.psendMsgNotifyWhileCommit((long)this.roleId, (int)141157, params);
        }
        if (petInfo.getLevel() > oldLevel) {
            ArrayList<String> param = new ArrayList<String>();
            param.add(pet.getName());
            param.add(Module.getInstance().getPetColorRGB(pet.getColor()));
            if (Transaction.current() == null) {
                MessageMgr.sendMsgNotify((long)this.roleId, (int)141404, param);
            } else {
                MessageMgr.psendMsgNotifyWhileCommit((long)this.roleId, (int)141404, param);
            }
        }
        if ((newLevel = petInfo.getLevel()) - oldLevel > 0) {
            pet.updatePetScoreWhileChange();
            CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)pet.getPetInfo().getPetscore());
            if (newLevel >= 60) {
                List<PetSkill> skills = pet.getBattleskills();
                for (PetSkill skill : skills) {
                    CourseManager.achieveCourse((long)this.roleId, (int)21, (int)skill.getSkillid(), (int)0);
                }
            }
        }
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SRefreshPetExp(this.petKey, petInfo.getExp()));
        this.onLog(this.roleId, petInfo.getKey(), petInfo.getUniqid(), petInfo.getId(), curExp, this.addExp, oldLevel, newLevel, this.reason);
        return true;
    }

    private void onLog(long roleId, int petKey, long uniqId, int petId, long curExp, long addExp, int oldLevel, int newLevel, int reason) {
        if (Module.logger.isInfoEnabled()) {
            Module.logger.info((Object)("[PAddPetExpProc] roleId:" + roleId + " petKey:" + petKey + " uniqId:" + uniqId + " petId:" + petId + " curExp:" + curExp + " addExp:" + addExp + " oldLevel:" + oldLevel + " newLevel:" + newLevel + " reason:" + reason));
        }
    }
}

